require("defines")

local function Round(n)

	return n % 1 >= 0.5 and math.ceil(n) or math.floor(n)

end

local function Basic_detection(UBS_table)

	for UBS_var_1 = 1, 1000000 do
		if UBS_table[UBS_var_1] then
			if UBS_table[UBS_var_1].neighbours[1] == nil then
				game.player.print("UBS has detected a disconnected basic underground belt at: " .. "X = " .. tostring(UBS_table[UBS_var_1].position.x) .. ", Y = " .. tostring(UBS_table[UBS_var_1].position.y) )
			else
				--a neighbour has been detected
			end
		else
			game.player.print("Detection has stopped, above this message you can see all the disconnected basic belts")
			game.player.print("You are now at: " .. "X = " .. tostring(Round(game.player.position.x)) .. ", Y = " .. tostring(Round(game.player.position.y)))
			break
		end
	end
end

local function Fast_detection(UBS_table)

	for UBS_var_1 = 1, 1000000 do
		if UBS_table[UBS_var_1] then
			if UBS_table[UBS_var_1].neighbours[1] == nil then
				game.player.print("UBS has detected a disconnected fast underground belt at: " .. "X = " .. tostring(UBS_table[UBS_var_1].position.x) .. ", Y = " .. tostring(UBS_table[UBS_var_1].position.y) )
			else
				--a neighbour has been detected
			end
		else
			game.player.print("Detection has stopped, above this message you can see all the disconnected fast belts")
			game.player.print("You are now at: " .. "X = " .. tostring(Round(game.player.position.x)) .. ", Y = " .. tostring(Round(game.player.position.y)))
			break
		end
	end
end

local function Express_detection(UBS_table)

	for UBS_var_1 = 1, 1000000 do
		if UBS_table[UBS_var_1] then
			if UBS_table[UBS_var_1].neighbours[1] == nil then
				game.player.print("UBS has detected a disconnected express underground belt at: " .. "X = " .. tostring(UBS_table[UBS_var_1].position.x) .. ", Y = " .. tostring(UBS_table[UBS_var_1].position.y) )
			else
				--a neighbour has been detected
			end
		else
			game.player.print("Detection has stopped, above this message you can see all the disconnected express belts")
			game.player.print("You are now at: " .. "X = " .. tostring(Round(game.player.position.x)) .. ", Y = " .. tostring(Round(game.player.position.y)))
			break
		end
	end
end

local function BuildTableBTPBTG()

		UBS_table_BTBTG = game.get_surface(1).find_entities_filtered{area = {{-100000, -100000}, {100000, 100000}}, name= "basic-transport-belt-to-ground"}
--		game.player.print("UBS: Table has been built, checking for non connected underground belts now.")
		Basic_detection(UBS_table_BTBTG)

end

local function BuildTableFTPBTG()

		UBS_table_FTBTG = game.surfaces["nauvis"].find_entities_filtered{area = {{-100000, -100000}, {100000, 100000}}, name= "fast-transport-belt-to-ground"}
--		game.player.print("UBS: Table has been built, checking for non connected underground belts now.")
		Fast_detection(UBS_table_FTBTG)


end

local function BuildTableETPBTG()

		UBS_table_ETBTG = game.surfaces["nauvis"].find_entities_filtered{area = {{-100000, -100000}, {100000, 100000}}, name= "express-transport-belt-to-ground"}
--		game.player.print("UBS: Table has been built, checking for non connected underground belts now.")
		Express_detection(UBS_table_ETBTG)


end

script.on_event(defines.events.on_tick, function(event)

	if not UBS_var_dns then
		if not UBS_var2 then
			UBS_var2 = 0
		end

		if UBS_var2 == 60 then
			if not game.player.gui.left.UBS_frame then
				game.player.gui.left.add{type = "frame", name = "UBS_frame", caption = "Do you want to check for non-connected underground belt?", direction = "vertical"}
				game.player.gui.left.UBS_frame.add{type = "label", name = "UBS_lbl_warning", caption = "Warning, this might take longer than 2 minutes, depending on the speed of your machine."}
				game.player.gui.left.UBS_frame.add{type = "button", name = "UBS_button_basic", caption = "Check basic belts"}
				game.player.gui.left.UBS_frame.add{type = "button", name = "UBS_button_fast", caption = "Check fast belts"}
				game.player.gui.left.UBS_frame.add{type = "button", name = "UBS_button_express", caption = "Check express belts"}
				game.player.gui.left.UBS_frame.add{type = "button", name = "UBS_button_all", caption = "Check all belt types"}
				game.player.gui.left.UBS_frame.add{type = "button", name = "UBS_button_not", caption = "Close"}
			end
		else
			UBS_var2 = UBS_var2 + 1
		end
	end

end)

script.on_event(defines.events.on_gui_click, function(event)
	if event.element.name == "UBS_button_basic" then
--		game.player.gui.left.UBS_frame.destroy()
		UBS_var_dns = true
		BuildTableBTPBTG()
	elseif event.element.name == "UBS_button_fast" then
--		game.player.gui.left.UBS_frame.destroy()
		UBS_var_dns = true
		BuildTableFTPBTG()
	elseif event.element.name == "UBS_button_express" then
--		game.player.gui.left.UBS_frame.destroy()
		UBS_var_dns = true
		BuildTableETPBTG()
	elseif event.element.name == "UBS_button_all" then
--		game.player.gui.left.UBS_frame.destroy()
		UBS_var_dns = true
--		game.player.print("This will certainly take a long time, the game is going through 10000000000 tiles three time to check if there are any disconnected underground belts, you better grab some coffee or a snack. \n")
		BuildTableBTPBTG()
		BuildTableFTPBTG()
		BuildTableETPBTG()
	elseif event.element.name == "UBS_button_not" then
		game.player.gui.left.UBS_frame.destroy()
		UBS_var_dns = true
	end
end)